<?php

/* --------------------------------------------------------------
   ContentRepositoryInterface.php 2019-04-16
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2019 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/**
 * Interface ContentRepositoryInterface
 *
 * @category   System
 * @package    Content
 * @subpackage Interfaces
 */
interface ContentRepositoryInterface
{
    /**
     * Save the info page content
     *
     * @param InfoPageContent $infoPageContent Info page content
     *
     * @return ContentRepositoryInterface Same instance for chained method calls
     */
    public function storeInfoPageContent(InfoPageContent $infoPageContent);
    
    
    /**
     * Save the link page content
     *
     * @param LinkPageContent $linkPageContent Link page content
     *
     * @return ContentRepositoryInterface Same instance for chained method calls
     */
    public function storeLinkPageContent(LinkPageContent $linkPageContent);
    
    
    /**
     * Save the info element content
     *
     * @param InfoElementContent $infoElementContent Info element content
     *
     * @return ContentRepositoryInterface Same instance for chained method calls
     */
    public function storeInfoElementContent(InfoElementContent $infoElementContent);
}