<?php
/* --------------------------------------------------------------
  CookieConsentPanelInstallationStatus.php 2019-12-20
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2019 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------*/

use Gambio\CookieConsentPanel\Storage\CookieConsentPanelStorage;

/**
 * Class CookieConsentPanelInstallationStatus
 */
class CookieConsentPanelInstallationStatus implements InstallationStatusInterface
{
    
    const CONFIGURATION_KEY = 'MODULE_CENTER_GAMBIOCOOKIECONSENTPANEL_INSTALLED';
    
    /**
     * @var bool
     */
    protected $moduleIsInstalled;
    
    /**
     * @var CookieConsentPanelStorage
     */
    protected $storage;
    
    
    /**
     * CookieConsentPanelInstallationStatus constructor.
     *
     * @param bool $moduleIsInstalled
     */
    public function __construct($moduleIsInstalled)
    {
        $this->moduleIsInstalled = $moduleIsInstalled;
    }
    
    
    /**
     * @return static
     */
    public static function create()
    {
        $configuration = gm_get_conf(self::CONFIGURATION_KEY);
        
        return new static($configuration === '1');
    }
    
    /**
     * @inheritDoc
     */
    public function isInstalled()
    {
        return $this->moduleIsInstalled && $this->storage()->get('active') === '1';
    }
    
    
    /**
     * @return CookieConsentPanelStorage
     */
    protected function storage()
    {
        if ($this->storage === null) {
            
            $this->storage = new CookieConsentPanelStorage;
        }
        
        return $this->storage;
    }
}