<?php

/* --------------------------------------------------------------
  PurposeUpdateDto.php 2020-01-13
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2020 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------*/
namespace Gambio\CookieConsentPanel\Services\Purposes\DataTransferObjects;

use Gambio\CookieConsentPanel\Services\Purposes\Interfaces\PurposeUpdateDtoInterface;
/**
 * Class PurposeUpdateDto
 * @package Gambio\CookieConsentPanel\Services\Purposes\DataTransferObjects
 */
class PurposeUpdateDto implements PurposeUpdateDtoInterface
{
    /**
     * @var string|null
     */
    protected $alias;
    /**
     * @var int
     */
    protected $categoryId;
    /**
     * @var bool
     */
    protected $deletable;
    /**
     * @var array
     */
    protected $descriptions;
    /**
     * @var int|null
     */
    protected $id;
    /**
     * @var array
     */
    protected $names;
    /**
     * @var bool
     */
    protected $status;
    /**
     * PurposeReaderDataTransferObject constructor.
     *
     * @param int         $categoryId
     * @param array       $descriptions
     * @param array       $names
     * @param bool        $status
     * @param bool        $deletable
     * @param string|null $alias
     * @param int|null    $id
     */
    public function __construct($categoryId, array $descriptions, array $names, $status, $deletable, $alias, $id)
    {
        $this->categoryId = $categoryId;
        $this->descriptions = $descriptions;
        $this->names = $names;
        $this->status = $status;
        $this->deletable = $deletable;
        $this->alias = $alias;
        $this->id = $id;
    }
    /**
     * @return int
     */
    public function categoryId()
    {
        return $this->categoryId;
    }
    /**
     * @return array
     */
    public function descriptions()
    {
        return $this->descriptions;
    }
    /**
     * @return array
     */
    public function names()
    {
        return $this->names;
    }
    /**
     * @return bool
     */
    public function status()
    {
        return $this->status;
    }
    /**
     * @return bool
     */
    public function deletable()
    {
        return $this->deletable;
    }
    /**
     * @return string|null
     */
    public function alias()
    {
        return $this->alias;
    }
    /**
     * @return int|null
     */
    public function id()
    {
        return $this->id;
    }
    /**
     * @inheritDoc
     */
    public function description($languageId)
    {
        return $this->descriptions[$languageId] ?: null;
    }
    /**
     * @inheritDoc
     */
    public function name($languageId)
    {
        return $this->names[$languageId] ?: null;
    }
}