<?php
/* --------------------------------------------------------------
   xtc_rand.inc.php 2019-12-06
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2019 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/**
 * @param int $min
 * @param int $max
 *
 * @return int
 * @throws Exception
 */
function xtc_rand($min = 0, $max = 9999999999)
{
    $min  = (int)floor($min);
    $max  = (int)floor($max);
    $diff = $max - $min;
    
    if ($diff <= 0) {
        
        return $min;
    }
    
    $range  = $diff + 1;
    $length = (int)(log($range, 2) / 8) + 1;
    $max    = (int)pow(2, 8 * $length);
    
    do {
        
        $strong = false; // Determines if the algorithm used was "cryptographically strong", e.g., safe for usage with GPG, passwords, etc.
        $bytes  = openssl_random_pseudo_bytes($length, $strong);
        
        if ($strong === false || $bytes === false) {
            
            $bytes = random_bytes($length);
        }
        
        $result = hexdec(bin2hex($bytes));
    } while ($result > $max);
    
    return ($result % $range) + $min;
}